4.8. Warnings and sanity-checking
Prev | Chapter 4. Using GHC | Next

## 4.8. Warnings and sanity-checking

GHC has a number of options that select which types of non-fatal error messages, otherwise known as warnings, can be generated during compilation. By default, you get a standard set of warnings which are generally likely to indicate bugs in your program. These are: `-fwarn-overlapping-patterns`, `-fwarn-warnings-deprecations`, `-fwarn-deprecated-flags`, `-fwarn-duplicate-exports`, `-fwarn-missing-fields`, `-fwarn-missing-methods`, `-fwarn-lazy-unlifted-bindings`, `-fwarn-wrong-do-bind`, and `-fwarn-dodgy-foreign-imports`. The following flags are simple ways to select standard “packages” of warnings:

`-W`:

  Provides the standard warnings plus `-fwarn-incomplete-patterns`, `-fwarn-dodgy-exports`, `-fwarn-dodgy-imports`, `-fwarn-unused-matches`, `-fwarn-unused-imports`, and `-fwarn-unused-binds`.

`-Wall`:

  Turns on all warning options that indicate potentially suspicious code. The warnings that are not enabled by `-Wall` are `-fwarn-tabs`, `-fwarn-incomplete-record-updates`, `-fwarn-monomorphism-restriction`, `-fwarn-unused-do-bind`, and `-fwarn-implicit-prelude`.

`-w`:

  Turns off all warnings, including the standard ones and those that `-Wall` doesn't enable.

`-Werror`:

  Makes any warning into a fatal error. Useful so that you don't miss warnings when doing batch compilation.

`-Wwarn`:

  Warnings are treated only as warnings, not as errors. This is the default, but can be useful to negate a `-Werror` flag.

The full set of warning options is described below. To turn off any warning, simply give the corresponding `-fno-warn-...` option on the command line.

`-fwarn-unrecognised-pragmas`:

  Causes a warning to be emitted when a pragma that GHC doesn't recognise is used. As well as pragmas that GHC itself uses, GHC also recognises pragmas known to be used by other tools, e.g. `OPTIONS_HUGS` and `DERIVE`.

  This option is on by default.

`-fwarn-warnings-deprecations`:

  Causes a warning to be emitted when a module, function or type with a WARNING or DEPRECATED pragma is used. See Section 7.13.4, “WARNING and DEPRECATED pragmas” for more details on the pragmas.

  This option is on by default.

`-fwarn-deprecated-flags`:

  Causes a warning to be emitted when a deprecated commandline flag is used.

  This option is on by default.

`-fwarn-dodgy-foreign-imports`:

  Causes a warning to be emitted for foreign imports of the following form:

      foreign import "f" f :: FunPtr t

  on the grounds that it probably should be

      foreign import "&f" f :: FunPtr t

  The first form declares that `f` is a (pure) C function that takes no arguments and returns a pointer to a C function with type `t`, whereas the second form declares that `f` itself is a C function with type `t`. The first declaration is usually a mistake, and one that is hard to debug because it results in a crash, hence this warning.

`-fwarn-dodgy-exports`:

  Causes a warning to be emitted when a datatype `T` is exported with all constructors, i.e. `T(..)`, but is it just a type synonym.

  Also causes a warning to be emitted when a module is re-exported, but that module exports nothing.

`-fwarn-dodgy-imports`:

  Causes a warning to be emitted when a datatype `T` is imported with all constructors, i.e. `T(..)`, but has been exported abstractly, i.e. `T`.

`-fwarn-lazy-unlifted-bindings`:

  Causes a warning to be emitted when an unlifted type is bound in a way that looks lazy, e.g. `where (I# x) = ...`. Use `where !(I# x) = ...` instead. This will be an error, rather than a warning, in GHC 7.2.

`-fwarn-duplicate-exports`:

  Have the compiler warn about duplicate entries in export lists. This is useful information if you maintain large export lists, and want to avoid the continued export of a definition after you've deleted (one) mention of it in the export list.

  This option is on by default.

`-fwarn-hi-shadowing`:

  Causes the compiler to emit a warning when a module or interface file in the current directory is shadowing one with the same module name in a library or other directory.

`-fwarn-implicit-prelude`:

  Have the compiler warn if the Prelude is implicitly imported. This happens unless either the Prelude module is explicitly imported with an `import ... Prelude ...` line, or this implicit import is disabled (either by `-XNoImplicitPrelude` or a `LANGUAGE NoImplicitPrelude` pragma).

  Note that no warning is given for syntax that implicitly refers to the Prelude, even if `-XNoImplicitPrelude` would change whether it refers to the Prelude. For example, no warning is given when `368` means `Prelude.fromInteger (368::Prelude.Integer)` (where `Prelude` refers to the actual Prelude module, regardless of the imports of the module being compiled).

  This warning is off by default.

`-fwarn-incomplete-patterns`:

  Similarly for incomplete patterns, the functions `g` and `h` below will fail when applied to non-empty lists, so the compiler will emit a warning about this when `-fwarn-incomplete-patterns` is enabled.

      g [] = 2
      h = \[] -> 2

  This option isn't enabled by default because it can be a bit noisy, and it doesn't always indicate a bug in the program. However, it's generally considered good practice to cover all the cases in your functions.

`-fwarn-incomplete-record-updates`:

  The function `f` below will fail when applied to `Bar`, so the compiler will emit a warning about this when `-fwarn-incomplete-record-updates` is enabled.

      data Foo = Foo { x :: Int }
               | Bar

      f :: Foo -> Foo
      f foo = foo { x = 6 }

  This option isn't enabled by default because it can be very noisy, and it often doesn't indicate a bug in the program.

`-fwarn-missing-fields`:

  This option is on by default, and warns you whenever the construction of a labelled field constructor isn't complete, missing initializers for one or more fields. While not an error (the missing fields are initialised with bottoms), it is often an indication of a programmer error.

`-fwarn-missing-methods`:

  This option is on by default, and warns you whenever an instance declaration is missing one or more methods, and the corresponding class declaration has no default declaration for them.

  The warning is suppressed if the method name begins with an underscore. Here's an example where this is useful:

      	      class C a where
      	        _simpleFn :: a -> String
      	        complexFn :: a -> a -> String
      	        complexFn x y = ... _simpleFn ...

  The idea is that: (a) users of the class will only call `complexFn`; never `_simpleFn`; and (b) instance declarations can define either `complexFn` or `_simpleFn`.

`-fwarn-missing-signatures`:

  If you would like GHC to check that every top-level function/value has a type signature, use the `-fwarn-missing-signatures` option. As part of the warning GHC also reports the inferred type. The option is off by default.

`-fwarn-name-shadowing`:

  This option causes a warning to be emitted whenever an inner-scope value has the same name as an outer-scope value, i.e. the inner value shadows the outer one. This can catch typographical errors that turn into hard-to-find bugs, e.g., in the inadvertent capture of what would be a recursive call in `f = ... let f = id in ... f ...`.

  The warning is suppressed for names beginning with an underscore. For example

                   f x = do { _ignore <- this; _ignore <- that; return (the other) }

`-fwarn-orphans`:

  This option causes a warning to be emitted whenever the module contains an "orphan" instance declaration or rewrite rule. An instance declaration is an orphan if it appears in a module in which neither the class nor the type being instanced are declared in the same module. A rule is an orphan if it is a rule for a function declared in another module. A module containing any orphans is called an orphan module.

  The trouble with orphans is that GHC must pro-actively read the interface files for all orphan modules, just in case their instances or rules play a role, whether or not the module's interface would otherwise be of any use. See Section 4.7.12, “Orphan modules and instance declarations” for details.

`-fwarn-overlapping-patterns`:

  By default, the compiler will warn you if a set of patterns are overlapping, e.g.,

      f :: String -> Int
      f []     = 0
      f (_:xs) = 1
      f "2"    = 2

  where the last pattern match in `f` won't ever be reached, as the second pattern overlaps it. More often than not, redundant patterns is a programmer mistake/error, so this option is enabled by default.

`-fwarn-tabs`:

  Have the compiler warn if there are tabs in your source file.

  This warning is off by default.

`-fwarn-type-defaults`:

  Have the compiler warn/inform you where in your source the Haskell defaulting mechanism for numeric types kicks in. This is useful information when converting code from a context that assumed one default into one with another, e.g., the ‘default default’ for Haskell 1.4 caused the otherwise unconstrained value `1` to be given the type `Int`, whereas Haskell 98 and later defaults it to `Integer`. This may lead to differences in performance and behaviour, hence the usefulness of being non-silent about this.

  This warning is off by default.

`-fwarn-monomorphism-restriction`:

  Have the compiler warn/inform you where in your source the Haskell Monomorphism Restriction is applied. If applied silently the MR can give rise to unexpected behaviour, so it can be helpful to have an explicit warning that it is being applied.

  This warning is off by default.

`-fwarn-unused-binds`:

  Report any function definitions (and local bindings) which are unused. For top-level functions, the warning is only given if the binding is not exported.

  A definition is regarded as "used" if (a) it is exported, or (b) it is mentioned in the right hand side of another definition that is used, or (c) the function it defines begins with an underscore. The last case provides a way to suppress unused-binding warnings selectively.

  Notice that a variable is reported as unused even if it appears in the right-hand side of another unused binding.

`-fwarn-unused-imports`:

  Report any modules that are explicitly imported but never used. However, the form `import M()` is never reported as an unused import, because it is a useful idiom for importing instance declarations, which are anonymous in Haskell.

`-fwarn-unused-matches`:

  Report all unused variables which arise from pattern matches, including patterns consisting of a single variable. For instance `f x y = []` would report `x` and `y` as unused. The warning is suppressed if the variable name begins with an underscore, thus:

      	       f _x = True

`-fwarn-unused-do-bind`:

  Report expressions occuring in `do` and `mdo` blocks that appear to silently throw information away. For instance `do { mapM popInt xs ; return 10 }` would report the first statement in the `do` block as suspicious, as it has the type `StackM [Int]` and not `StackM ()`, but that `[Int]` value is not bound to anything. The warning is suppressed by explicitly mentioning in the source code that your program is throwing something away:

      	       do { _ <- mapM popInt xs ; return 10 }

  Of course, in this particular situation you can do even better:

      	       do { mapM_ popInt xs ; return 10 }

`-fwarn-wrong-do-bind`:

  Report expressions occuring in `do` and `mdo` blocks that appear to lack a binding. For instance `do { return (popInt 10) ; return 10 }` would report the first statement in the `do` block as suspicious, as it has the type `StackM (StackM Int)` (which consists of two nested applications of the same monad constructor), but which is not then "unpacked" by binding the result. The warning is suppressed by explicitly mentioning in the source code that your program is throwing something away:

      	       do { _ <- return (popInt 10) ; return 10 }

  For almost all sensible programs this will indicate a bug, and you probably intended to write:

      	       do { popInt 10 ; return 10 }

If you're feeling really paranoid, the `-dcore-lint` option is a good choice. It turns on heavyweight intra-pass sanity-checking within GHC. (It checks GHC's sanity, not yours.)

Prev | Up | Next
4.7. Filenames and separate compilation | Home | 4.9. Packages